/***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Original Code is "Plain Text To Link".
   -
   - The Initial Developer of the Original Code is Tommaso Beniero.
   - Portions created by the Initial Developer are Copyright (C) 2005 Tommaso Beniero.  
   - All Rights Reserved.
   -
   - Contributor(s): Tommaso Beniero <tommaso DOT beniero AT gmail DOT com>
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - 
***** END LICENSE BLOCK *****/

/* Thanks to Ted Mielczarek for the functions unmangleURL and fixURL

/*
 * Copyright (c) 2001-2002  Ted Mielczarek
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var myMenuItems = new Array("divisor", "pttl_menu", "pttl_menupopup", "open_window", "open_tab");

var pttl = {

	init: function() {
	
		var menu = document.getElementById("contentAreaContextMenu");

		menu.addEventListener("popupshowing",pttl.verSelText,false);

	},

	verSelText: function() {

		var isTextSelection = false;

		if(gContextMenu)
	
		isTextSelection = gContextMenu.isTextSelected;

		for(var i=0; i<myMenuItems.length; i++) {
		
			var menuitem = document.getElementById(myMenuItems[i]);
			
			if(menuitem) {
	
				menuitem.hidden = !isTextSelection;

			}
		
		}
	
	},

	openNewTab: function() {

		var URLAddress = this.getString();

		URLAddress = this.fixURL(this.unmangleURL(URLAddress));

		var tab=getBrowser().addTab(URLAddress);

		getBrowser().selectedTab=tab;
  	
	},
 
	openNewWindow: function() {
	
		var URLAddress = this.getString();

		URLAddress = this.fixURL(this.unmangleURL(URLAddress));		

		window.open(URLAddress);

	},

	getString: function() {

		var focusedWindow = document.commandDispatcher.focusedWindow;
	
		var hlText = focusedWindow.getSelection.call(focusedWindow);
	
		hlText = hlText.toString();

		return hlText;

	},  

	unmangleURL: function(url) {
	
    		url = url.replace(/[\n\t ]+/, "");
    
    		url = url.replace(/^[^a-zA-Z]+/, "");
    
    		url = url.replace(/[\.,\'\"\)\?!>\]]+$/, "");

    		return url;
	
	},

  	fixURL: function (url) {

    		if(url.search(/^\w+:\/\//) == -1) url = "http://" + url;

    		if(url.search(/^h.+p:\/\//) != -1) url = url.replace(/^h.+p:\/\//, "http://");

    		if(url.search(/^f.+p:\/\//) != -1) url = url.replace(/^f.+p:\/\//, "ftp://");

    		return url;
  
	}
}

window.addEventListener("load",pttl.init, false); 